#include <stdafx.h>
#include <string.h>
#include <stdio.h>
#include <windows.h>
#include <winbase.h>
#include <winuser.h>
#include <direct.h>
#include <Shlwapi.h>
#include <shellapi.h>
#include <commctrl.h> // pour InitCommonControls
#include <windowsx.h> // pour les Edit_SetText et autre ...
#include "listView.h"
#include "list.h"
#include "resource.h"

// ***************************************************************************************

#define WM_TRAY		WM_USER+1

#define APP_NAME	"WatchTray"

HINSTANCE hInst;

char extToFind[10]="*.exe";
typedef struct
{
	char dataTime[40];
	char action[30];
	char path[MAX_PATH];
	char oldPath[MAX_PATH];
	char result [128];
} TElem;

typedef struct
{
	char file[MAX_PATH];
} TFile;

typedef struct
{
	CListView *listView;
	CMyList <TElem> *list;
	CMyList <TFile> blackList;
	TElem *elem;
	char drive[_MAX_DRIVE];
} TParam;

//#define DEBUG
#define SIZE_BUFFER 4096

// ***************************************************************************************

/* --------------------------------------------------------------------------------------------------- 
	Dplace une fenetre dans le but de la placer dans le coin le plus proche des icon de tache
--------------------------------------------------------------------------------------------------- */

void MoveToBorderTask (HWND hUpdatingWnd)
{
	 if (!hUpdatingWnd) return ;

	 APPBARDATA Data ; 
	 memset (&Data, 0, sizeof(Data)) ;
	 Data.hWnd = hUpdatingWnd ;
	 SHAppBarMessage( ABM_GETTASKBARPOS , &Data) ;
	 RECT r ;
	 GetWindowRect (hUpdatingWnd , &r) ;

	 int cx = GetSystemMetrics(SM_CXSCREEN);
	 int cy = GetSystemMetrics(SM_CYSCREEN);
	 
	 if (Data.rc.top < 0 && Data.rc.left < 0 && Data.rc.right > cx) 
	 { // Barre de taches en haut
		MoveWindow (hUpdatingWnd, 
			cx - (r.right - r.left), 
			Data.rc.bottom - Data.rc.top, 
			r.right - r.left, 
			r.bottom - r.top, 
			FALSE); 
	 }
	 else if (Data.rc.bottom > cy && Data.rc.left < 0 && Data.rc.right > cx) 
	 { // Barre de taches en bas
		MoveWindow (hUpdatingWnd, 
			cx - (r.right - r.left), 
			cy - (Data.rc.bottom-Data.rc.top)-(r.bottom - r.top), 
			r.right - r.left, 
			r.bottom - r.top, 
			FALSE); 
	 } 
	 else if (Data.rc.top < 0 && Data.rc.left < 0 && Data.rc.bottom > cy) 
	 { // Barre de taches  gauche
		MoveWindow (hUpdatingWnd, 
			(Data.rc.right-Data.rc.left), 
			cy - (r.bottom - r.top), 
			r.right - r.left, 
			r.bottom - r.top, 
			FALSE); 
	 }
	 else if (Data.rc.top < 0 && Data.rc.bottom > cy && Data.rc.right > cx) 
	 { // Barre de taches  droite
		MoveWindow (hUpdatingWnd, 
			cx - (Data.rc.right-Data.rc.left)- (r.right - r.left), 
			cy -(r.bottom - r.top), 
			r.right - r.left, 
			r.bottom - r.top, 
			FALSE); 
	 }
	 else   
		 MoveWindow (hUpdatingWnd, 
			cx - (r.right - r.left), 
			cy - (Data.rc.bottom-Data.rc.top)-(r.bottom - r.top), 
			r.right - r.left, 
			r.bottom - r.top, 
			FALSE); 
 }     

// ***************************************************************************************

BOOL AddIconToTaskBar(HWND hWnd, UINT wMsg, HICON hIcon , char *Desc)
{ 
	NOTIFYICONDATA nid ;
	nid.cbSize	= sizeof(NOTIFYICONDATA) ;
	nid.hWnd	= hWnd ;
	nid.uID	= 1 ;
	nid.uFlags	= NIF_TIP | NIF_ICON | NIF_MESSAGE; 
	nid.uCallbackMessage = wMsg ; 
	nid.hIcon	= hIcon ; 
	strcpy(nid.szTip, Desc ) ; 
	return Shell_NotifyIcon(NIM_ADD, &nid) ;
}

// ***************************************************************************************

BOOL DelIconFromTaskBar(HWND hWnd)
{
	 NOTIFYICONDATA nid ;
	 nid.cbSize	= sizeof(NOTIFYICONDATA) ;
	 nid.hWnd	= hWnd ;
	 nid.uID	= 1 ;
	 return Shell_NotifyIcon(NIM_DELETE, &nid) ;
}

// ***************************************************************************************

BOOL ModifyIconInTaskBar(HWND hWnd, UINT wMsg, HICON hIcon , char *Desc)
{ 
	 NOTIFYICONDATA nid ;
	 nid.cbSize	= sizeof(NOTIFYICONDATA) ;
	 nid.hWnd	= hWnd ;
	 nid.uID	= 1 ;
	 nid.uFlags	= NIF_TIP | NIF_ICON | NIF_MESSAGE; 
	 nid.uCallbackMessage = wMsg ; 
	 nid.hIcon	= hIcon ; 
	 strcpy(nid.szTip, Desc ) ; 
	 return Shell_NotifyIcon(NIM_MODIFY, &nid) ;
}

// *****************************************************************************************

BOOL WCharToString(FILE_NOTIFY_INFORMATION *curBuffer,char *temp)
{
	if (!WideCharToMultiByte(CP_ACP,0, curBuffer->FileName, curBuffer->FileNameLength, temp, MAX_PATH,NULL, NULL)) 
		return FALSE;

	temp[curBuffer->FileNameLength/2]='\0';
	return TRUE;
}

// *****************************************************************************************
// deja present dans la blackList ?
BOOL FindString (CMyList<TFile> *list,char *file)
{
	TFile *ptrFile;
	for (list->GoFirst();list->More();list->GoNext())
	{
		ptrFile = list->GetElem();
		if (!strcmp(ptrFile->file,file)) return TRUE;
	}
	return FALSE;
}

DWORD WINAPI ThreadAction (IN LPVOID paramVoid)
{
	TParam *param= (TParam *) paramVoid;
	TElem elem;
	memcpy(&elem,param->elem,sizeof (TElem));

	for (int i=0;i<5;i++)
	{
		Sleep (i ? 10000 : 1000);
		if (MoveFile(elem.oldPath,elem.path)) 
		{
			sprintf(elem.result,"Ok");
			param->list->AddLast(elem);
			param->listView->SetNbCount(param->list->NbElem());
			param->listView->Refresh();
			break;
		}
		else sprintf(elem.result,"Error:%d (#%d)",GetLastError(),i+1);		

		param->list->AddLast(elem);
		param->listView->SetNbCount(param->list->NbElem());
		param->listView->Refresh();
	}

	Sleep (10000);
	// deja present dans la blackList ?
	if (FindString(&param->blackList,elem.oldPath))
	{
		param->blackList.SuprCurrent();
	}
	ExitThread(0);
    return 0;
}

// *****************************************************************************************

DWORD WINAPI ThreadProcedure (IN LPVOID paramVoid)
{
	TParam *param = (TParam *) paramVoid;
	TElem elem;
	TFile file;

	char temp[MAX_PATH];

	HANDLE hDirectory;

	BYTE _buffer[SIZE_BUFFER];
	FILE_NOTIFY_INFORMATION *curBuffer,*buffer = (FILE_NOTIFY_INFORMATION *)_buffer;

	DWORD bytesReturned;
	
	char szLocalDate[64];
	char szLocalTime[64];
	SYSTEMTIME st;

	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];

	while (1)
	{
		hDirectory = CreateFile(
			param->drive,							// pointer to the file name
			FILE_LIST_DIRECTORY,                // access (read-write) mode
			FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE,  // share mode
			NULL,                               // security descriptor
			OPEN_EXISTING,                      // how to create
			FILE_FLAG_BACKUP_SEMANTICS,         // file attributes
			NULL                                // file with attributes to copy
		);

		if (hDirectory == INVALID_HANDLE_VALUE)
		{
			#ifdef DEBUG
				printf("!Error: CreateFile\n");
			#endif
			CloseHandle(hDirectory);
			continue;
		}

		ZeroMemory(buffer,SIZE_BUFFER);
		
		if (!ReadDirectoryChangesW(
			hDirectory, // handle to the directory to be watched
			buffer,    // pointer to the buffer to receive the read results
			SIZE_BUFFER ,		// length of lpBuffer
			TRUE,		// flag for monitoring directory or directory tree
						// filter conditions to watch for
			FILE_NOTIFY_CHANGE_FILE_NAME |	//Any filename change in the watched directory or subtree causes a change notification wait operation to return. Changes include renaming, creating, or deleting a file.  
			FILE_NOTIFY_CHANGE_DIR_NAME |	//Any directory-name change in the watched directory or subtree causes a change notification wait operation to return. Changes include creating or deleting a directory. 
			FILE_NOTIFY_CHANGE_ATTRIBUTES | //Any attribute change in the watched directory or subtree causes a change notification wait operation to return. 
			FILE_NOTIFY_CHANGE_SIZE |		//Any file-size change in the watched directory or subtree causes a change notification wait operation to return. The operating system detects a change in file size only when the file is written to the disk. For operating systems that use extensive caching, detection occurs only when the cache is sufficiently flushed. 
			FILE_NOTIFY_CHANGE_LAST_WRITE | //Any change to the last write-time of files in the watched directory or subtree causes a change notification wait operation to return. The operating system detects a change to the last write-time only when the file is written to the disk. For operating systems that use extensive caching, detection occurs only when the cache is sufficiently flushed. 
			FILE_NOTIFY_CHANGE_LAST_ACCESS |//Any change to the last access time of files in the watched directory or subtree causes a change notification wait operation to return. 
			FILE_NOTIFY_CHANGE_CREATION |	//Any change to the creation time of files in the watched directory or subtree causes a change notification wait operation to return. 
			FILE_NOTIFY_CHANGE_SECURITY, 	//Any security-descriptor change in the watched directory or subtree causes a change notification wait operation to return 
			&bytesReturned,					// number of bytes returned
			NULL,		// pointer to structure needed for overlapped I/O
			NULL		// pointer to completion routine
		)) 
		{
			#ifdef DEBUG
				printf("!Error: ReadDirectoryChanges\n");
			#endif
			CloseHandle(hDirectory);
			continue;
		}
		
		CloseHandle(hDirectory);
		
		int nextOffset = 1;
		for (
			curBuffer = buffer;
			curBuffer && nextOffset ;
			curBuffer += curBuffer->NextEntryOffset)
		{
			if((curBuffer - buffer) > SIZE_BUFFER) break;
			
			nextOffset = curBuffer->NextEntryOffset;
			if (!WCharToString(curBuffer,temp))
			{
				#ifdef DEBUG
					printf("!Error: WideCharToMultiByte\n");
				#endif
				continue;
			}

			sprintf(elem.path,"%s%s",param->drive,temp);
			_splitpath(elem.path,drive,dir,fname,ext);
			strcpy (elem.oldPath,elem.path);

			if (strcmp(ext,extToFind)) continue;

			// deja present dans la blackList ?
			if (FindString(&param->blackList,elem.oldPath)) 
				continue;

			//if (buffer->Action != FILE_ACTION_ADDED) continue;
			
			switch (buffer->Action)
			{
				case FILE_ACTION_ADDED: // The file was added to the directory. 
					strcpy (elem.action,"Added"); break;
				case FILE_ACTION_REMOVED: // The file was removed from the directory. 
					strcpy (elem.action,"Removed"); continue;
				case FILE_ACTION_MODIFIED: // The file was modified. This can be a change in the time stamp or attributes. 
					strcpy (elem.action,"Modified"); break;
				case FILE_ACTION_RENAMED_NEW_NAME: // The file was renamed and this is the new name. 
				case FILE_ACTION_RENAMED_OLD_NAME: // The file was renamed and this is the old name. 
					strcpy (elem.action,"Renamed");	continue;
				default:
					strcpy (elem.action,"Unknown"); break;
			}		

			// sinon ajout dans la list
			strcpy (file.file,elem.path);
			param->blackList.AddLast(file);

			GetLocalTime(&st);
			GetDateFormat( LOCALE_USER_DEFAULT, DATE_SHORTDATE, &st, NULL,szLocalDate, 255 );
			GetTimeFormat( LOCALE_USER_DEFAULT, 0, &st, NULL, szLocalTime, 255 );

			sprintf(elem.dataTime,"%s %s",szLocalDate,szLocalTime);

			// renomage
			for (int i=1;i<4;i++) ext[i]=tolower(ext[i]);
			_makepath(elem.path,drive,dir,fname,ext);
			OutputDebugString("* Old: ");
			OutputDebugString(elem.oldPath);
			OutputDebugString("\n  New: ");
			OutputDebugString(elem.path);
			OutputDebugString(" \n");
			param->elem = &elem;
			DWORD uUnusedThreadId;
			HANDLE hChildThread = (HANDLE) CreateThread ( 
				NULL, 
				0, 
				ThreadAction, 
				(LPVOID) param, 
				0, 
				&uUnusedThreadId);
		}
		
	}
	ExitThread(0);
    return 0;
}

// ***************************************************************************************

LRESULT CALLBACK MainProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static CListView *listView;
	static CMyList <TElem> *list;

	static BOOL isRepportView;
	TElem *elem;
	static TParam *ptrParam;

	switch (message)
	{
		case WM_INITDIALOG:  
			list = new CMyList <TElem>;
			
			isRepportView = TRUE;
			listView = new CListView(GetDlgItem(hDlg,IDC_LIST));
			listView->AddColumn("Data/Time",120);
			listView->AddColumn("Action",60);
			listView->AddColumn("Path",190);
			listView->AddColumn("Result",68);
			
			AddIconToTaskBar(hDlg, WM_TRAY , LoadIcon( hInst, MAKEINTRESOURCE(ID_ICON_WATCH) ), APP_NAME) ;
			MoveToBorderTask(hDlg);

			ListView_SetExtendedListViewStyleEx(GetDlgItem(hDlg,IDC_LIST),LVS_EX_FULLROWSELECT,LVS_EX_FULLROWSELECT);

			// lancement des thread de monitoring
			DWORD uUnusedThreadId;
			char dir[MAX_PATH*2];
			char uniteString[3*26+2];
			if (!GetLogicalDriveStrings(3*26+2,uniteString)) 
			{
				printf("Erreur dans GetLogicalDriveStrings\n"); 
				return TRUE;
			}

			char *word;
			
			for (word=uniteString;*word;word += 4)
			{
				strcpy (dir,word);
				if (GetDriveType(dir) == DRIVE_FIXED)
				{
					ptrParam = new TParam;
					ptrParam->listView = listView;
					ptrParam->list = list;
					strcpy (ptrParam->drive,dir);
					CreateThread ( 
						NULL, 
						0, 
						ThreadProcedure, 
						(LPVOID) ptrParam, 
						0, 
						&uUnusedThreadId);
				}
			}

			return TRUE;


		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
				case IDCANCEL:
				case IDOK : 	
					EndDialog(hDlg,TRUE);
					return TRUE;
			}
			break;

		case WM_ACTIVATE:
			switch (LOWORD(wParam)) // fActive
			{
				case WA_ACTIVE:
					//ShowWindow(hDlg,SW_SHOW);
					SetForegroundWindow(hDlg);
					//SendMessage(NULL,0,0,0);
					break;
					
				case WA_CLICKACTIVE:
				case WA_INACTIVE:
					break;
			}
			return TRUE;

		case WM_NOTIFY:
			switch (LOWORD(wParam))
			{
				case IDC_LIST:
					ENotify res = listView->Notify(lParam);
					list->GoIndex(first,listView->GetLine());
					elem = list->GetElem();
					switch (res)
					{
						case getDispInfo:
							switch (listView->GetColumn())
							{
								case 0: // date/heure
									listView->SetItemText(elem->dataTime);
									return TRUE;
								case 1: // action
									listView->SetItemText(elem->action);
									return TRUE;
								case 2: // path
									listView->SetItemText(elem->path);
									return TRUE;
								case 3: // result
									listView->SetItemText(elem->result);
									return TRUE;
							}
					}
					return TRUE;
			}
			break;

		case WM_DESTROY:
			DelIconFromTaskBar(hDlg) ;
			PostQuitMessage(0);
			return TRUE;

		case WM_TRAY : 
			switch (lParam)
			{
				case WM_LBUTTONDBLCLK: 
					isRepportView = !isRepportView;
					ShowWindow(hDlg,isRepportView ? SW_SHOW : SW_HIDE);
					return TRUE;

				case WM_RBUTTONDOWN:  
					return TRUE;
			}	
			break ;
	}	
	return FALSE;
	
}

// ***************************************************************************************

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	if (lpCmdLine[0])
	{
		strcpy(extToFind,lpCmdLine);
	}
	hInst = hInstance;

	InitCommonControls(); // ajouter "comctl32.lib" dans les settings
	DialogBox(hInstance,MAKEINTRESOURCE(IDD_REPPORT),NULL,(DLGPROC) MainProc);

	return 0;
}



