#ifndef INCLUDE_LISTE_GENERIQUE_H
#define INCLUDE_LISTE_GENERIQUE_H
/*
#ifndef BOOL // gestion des cross-platform
	#define BOOL	short
	#define TRUE	1
	#define FALSE	0
#endif
*/
#include <stdio.h>

/* **********************************************************************************
	// Ex: liste de int;

	CMyListe <int> listInt;

	int num;
	num = 12;
	listInt.AddFirst(&num);
	num = 13;
	listInt.AddFirst(&num);
	num = 14;
	listInt.AddLast(&num);
	num = 15;
	listInt.AddAfterCurrent(&num);
	num = 16;
	listInt.AddBeforCurrent(&num);
	num = 17;
	listInt.AddFirst(&num);

	for (listInt.GoFirst();listInt.IsEnding();listInt.GoNext())
	{
		int *last;
		last = listInt.GetElem();
		sprintf(temp,"%d",*last);
	}
	// ==> 17,13,12,14,16,15
********************************************************************************** */

#define ABS(value) (value<0 ? -value : value)

typedef enum
{
	current = 1,first,last,befor,next
} ETypeStart; // pour le param1 de GoIndex

template <class T> class CMyList
{
	typedef struct List_
	{
	  T *elem; 							// element de la liste 
	  struct List_ *next,*befor;       // sucesseur 
	} *List, ElemList;

	private:
		List	m_first;
		List	m_last;
		List	m_current;
		int		m_nbElem;

	public:
		/* **********************************************************************************
			Init de la liste
		********************************************************************************** */

		CMyList ()
		{
			m_first = NULL;
			m_current = NULL;
			m_last = NULL;
			m_nbElem = 0;
		}


		/* **********************************************************************************
		   liberation d'une liste
		********************************************************************************** */

		~CMyList ()
		{
			SuprAll();
		}


		/* **********************************************************************************
			Cree un element de la liste avec comme valuer l'element lui meme alloue et recopi de l'original
		********************************************************************************** */

		List NewElem (T &elem)
		{
			List liste = new (ElemList);
			liste->next=NULL;
			liste->befor=NULL;
			liste->elem = new(T);
			memcpy(liste->elem,&elem,sizeof(T));
			//liste->elem=elem;

			return liste;
		}


		/* **********************************************************************************
			Efface un elem de list et sa valeur associ
		********************************************************************************** */

		BOOL DelElem (List l)
		{
			if (l == NULL) return FALSE;
			delete l->elem;
			delete l;
			return TRUE;
		}


		/* **********************************************************************************
			Ajout en debut de liste
		********************************************************************************** */

		BOOL AddFirst (T &elem)
		{
			List lNew;
			lNew = NewElem (elem);
			if (lNew == NULL) return FALSE;
			if (m_first == NULL) m_current = m_first = m_last = lNew;  
			else 
			{
				m_first->befor = lNew;
				lNew->next = m_first;
				m_first = lNew;
				m_current = lNew;
			}
			m_nbElem ++;
			return TRUE;
		}


		/* **********************************************************************************
			Ajout en fin de liste
		********************************************************************************** */

		BOOL AddLast (T &elem)
		{
			List lNew;
			lNew = NewElem (elem);
			if (lNew == NULL) return FALSE;
			if (m_last == NULL) m_current = m_first = m_last = lNew;  
			else 
			{
				m_last->next = lNew;
				lNew->befor = m_last;
				m_last = lNew;
				m_current = lNew;
			}
			m_nbElem ++;
			return TRUE;
		}


		/* **********************************************************************************
			Ajourt avant le current
		********************************************************************************** */

		BOOL AddBeforCurrent(T &elem)
		{
			List lNew;
			lNew = NewElem (elem);
			if (lNew == NULL) return FALSE;
			if (m_current == NULL)  
			{
				if (m_first == NULL && m_last == NULL) m_first = m_last = m_current = lNew;
				else return FALSE;
			}
			else 
			{
				if (m_current == m_first)
				{
					m_first->befor = lNew;
					lNew->next = m_first;
					m_first = m_current = lNew;
				}
				else
				{
					lNew->befor = m_current->befor;
					m_current->befor->next = lNew;
					m_current->befor = lNew;
					lNew->next = m_current;
					m_current = lNew;
				}
			}
			m_nbElem ++;
			return TRUE;
		}


		/* **********************************************************************************
			Ajout pares le current
		********************************************************************************** */

		BOOL AddAfterCurrent(T &elem)
		{
			List lNew;
			lNew = NewElem (elem);
			if (lNew == NULL) return FALSE;
			if (m_current == NULL) 
			{
				if (m_first == NULL && m_last == NULL) m_first = m_last = m_current = lNew;
				else return FALSE;
			}
			else 
			{
				if (m_current == m_last)
				{
					m_last->next = lNew;
					lNew->befor  = m_last;
					m_last = m_current = lNew;
				}
				else
				{
					lNew->next = m_current->next;
					m_current->next->befor = lNew;
					m_current->next = lNew;
					lNew->befor = m_current;
					m_current = lNew;
				}
			}
			m_nbElem ++;
			return TRUE;
		}


		/* **********************************************************************************
		   Supression d'un element dans la liste en tete
		********************************************************************************** */

		BOOL SuprFirst ()
		{
			if (m_first == NULL) return FALSE;
			List temp;

			temp = m_first->next;
			DelElem(m_first);
			if (temp == NULL) m_current = m_first = m_last = NULL;
			else
			{
				temp->befor = NULL;
				m_current = m_first = temp;
			}
			m_nbElem --;
			return TRUE;
		}


		/* **********************************************************************************
		   Supression d'un element dans la liste en fin
		********************************************************************************** */

		BOOL SuprLast ()
		{
			if (m_last == NULL) return FALSE;
			List temp;

			temp = m_last->befor;
			DelElem(m_last);
			if (temp == NULL) m_current = m_first = m_last = NULL;
			else
			{
				temp->next = NULL;
				m_current = m_last = temp;
			}
			m_nbElem --;
			return TRUE;		
		}


		/* **********************************************************************************
		   Supression d'un element dans la liste courante
		********************************************************************************** */

		BOOL SuprCurrent ()
		{
			if (m_current == NULL) return FALSE;
			List lNext,lBefor,lOld;

			lNext = m_current->next;
			lBefor = m_current->befor;
			lOld = m_current;

			if (lBefor == NULL && lNext == NULL)
			{
				m_first = m_last = m_current = NULL;	
			}
			else
			{
				if (lBefor != NULL) 
				{
					lBefor->next=lNext;
					if (lNext != NULL) 
					{
						lNext->befor = lBefor;
						m_current = lNext;
					}
					else m_last = m_current = lBefor;
				}
				else 
				{
					m_first = lNext;
					lNext->befor = NULL;
				}
			}
			DelElem(lOld);
			m_nbElem --;
			return TRUE;
		}


		/* **********************************************************************************
		   Supression de tout les elements
		********************************************************************************** */

		BOOL SuprAll ()
		{
			List temp;
			for (GoFirst();More();m_current = temp) 
			{
				temp = m_current->next;
				DelElem(m_current);
			}
			m_current = NULL;
			m_first = NULL;
			m_last = NULL;
			m_nbElem = 0;
			return TRUE;
		}


		/* **********************************************************************************
		   Compte le nb d'element dans la liste
		********************************************************************************** */
  
		int NbElem()
		{
			return m_nbElem;
		}


		/* **********************************************************************************
			Va apres
		********************************************************************************** */

		BOOL GoNext ()
		{
			if (m_current != NULL) m_current = m_current->next;
			return m_current ? TRUE : FALSE;
		}


		/* **********************************************************************************
			Va avant
		********************************************************************************** */

		BOOL GoBefor ()
		{
			if (m_current != NULL) m_current = m_current->befor;
			return m_current ? TRUE : FALSE;
		}


		/* **********************************************************************************
			Va au debut
		********************************************************************************** */

		BOOL GoFirst ()
		{
			m_current = m_first;
			return m_current ? TRUE : FALSE;				
		}


		/* **********************************************************************************
			Va depuis curent,first,last,befor,next deplace de nb infos
		********************************************************************************** */

		BOOL GoIndex (ETypeStart start,int nb)
		{
			BOOL isUp;
			isUp = nb<0 ? FALSE : TRUE ; 
			nb = ABS(nb);
			switch (start)
			{
				case current: break;
				case first: isUp = TRUE;  GoFirst(); break;
				case last:  isUp = FALSE; GoLast();  break;
				case befor: isUp = FALSE; break;
				case next:  isUp = TRUE;  break;
				default:
					return FALSE;
			}
			for (int i=0;i<nb;i++)
			{
				if (More())
				{
					if (isUp) GoNext();
					else GoBefor();
				} else return FALSE;
			}
			return TRUE;
		}

		
		/* **********************************************************************************
			Va a la fin
		********************************************************************************** */

		BOOL GoLast ()
		{
			m_current = m_last;
			return m_current ? TRUE : FALSE;
		}


		/* **********************************************************************************
			Donne un ptr sur l'element de la liste
		********************************************************************************** */

		T * GetElem ()
		{
			if (m_current == NULL) return FALSE;
			return m_current->elem;
		}


		/* **********************************************************************************
			enumeration termin ?
		********************************************************************************** */

		BOOL More ()
		{
			return m_current ? TRUE : FALSE;
		}		


		/* **********************************************************************************
			Sauve les donne valide dans un fichier deja ouvert en ecriture 
		********************************************************************************** */

		BOOL SaveData (FILE *fich)
		{
			if (fich == NULL) return FALSE;

			fprintf(fich,"%d",m_nbElem);
			for (GoFirst();More();GoNext())
			{
				if (m_current->elem != NULL)
					if (!fwrite ((void *) m_current->elem,sizeof(T),1,fich)) return FALSE;
			}
			return TRUE;
		}


		/* **********************************************************************************
			Ajoute les donne a partir d'un fichier deja ouvert en lecture
		********************************************************************************** */

		BOOL LoadData (FILE *fich)
		{
			if (fich == NULL) return FALSE;
			
			int i,nb;
			T elem;
			fscanf(fich,"%d",&nb);
			for (i=0;i<nb;i++)
			{
				if (!fread ((void *) &elem,sizeof(T),1,fich))return FALSE;
				if (!AddAfterCurrent(elem)) return FALSE;
			}
			return TRUE;
		}
};

//typedef CMyList<int> CMyListInt;
//typedef CMyList<float> CMyListFloat;

#endif
